"use strict";
cc._RF.push(module, '335fea4K1JFqanJyztUAUJR', 'scene');
// mz_z_06/script/scene.js

"use strict";

var _util = require("./util");

// Learn cc.Class:
//  - https://docs.cocos.com/creator/manual/en/scripting/class.html
// Learn Attribute:
//  - https://docs.cocos.com/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - https://docs.cocos.com/creator/manual/en/scripting/life-cycle-callbacks.html
cc.Class({
  "extends": cc.Component,
  properties: {
    baseWidth: {
      "default": 1280,
      type: cc.Integer
    },
    baseHeight: {
      "default": 720,
      type: cc.Integer
    } // foo: {
    //     // ATTRIBUTES:
    //     default: null,        // The default value will be used only when the component attaching
    //                           // to a node for the first time
    //     type: cc.SpriteFrame, // optional, default is typeof default
    //     serializable: true,   // optional, default is true
    // },
    // bar: {
    //     get () {
    //         return this._bar;
    //     },
    //     set (value) {
    //         this._bar = value;
    //     }
    // },

  },
  // LIFE-CYCLE CALLBACKS:
  // baseWidth: 1280;
  // baseHeight: 720;
  onLoad: function onLoad() {
    this.initSceneData();
    this.initSize();
  },
  initSceneData: function initSceneData() {
    this._imageResList = [];
    this._audioResList = [];
    this._animaResList = [];
  },
  _designSize: null,
  initSize: function initSize() {
    this._designSize = cc.view.getDesignResolutionSize();
  },
  start: function start() {
    var _this = this;

    var getData = this.getData.bind(this);

    if (window && window.courseware) {
      // console.log('has window');
      getData = window.courseware.getData;
    }

    getData(function (data) {
      console.log('data:', data);
      _this.data = data || _this.getDefaultData();
      _this.data = JSON.parse(JSON.stringify(_this.data));

      _this.preloadItem();
    });
  },
  _imageResList: null,
  _audioResList: null,
  _animaResList: null,
  preloadItem: function preloadItem() {
    this.addPreloadImage();
    this.addPreloadAudio();
    this.addPreloadAnima();
    this.preload();
  },
  getData: function getData(func) {
    func(this.getDefaultData());
  },
  getDefaultData: function getDefaultData() {
    var dataJson = '{"groupArr":[{"title":"","letter":"A","audio_url":"http://staging-teach.cdn.ireadabc.com/22e9facddfbf087ecdf2b60dba6019ef.mp3","bg":"1","picArr":[{"letter":"a","word":"aab","pic_url":"http://staging-teach.cdn.ireadabc.com/c8abf7383d65bcbdba8f390785cece60.png","audio_url":"http://staging-teach.cdn.ireadabc.com/f51e3fedc88aa69a99f6ef579f7de047.mp3","text":""},{"letter":"b","word":"bcd","pic_url":"http://staging-teach.cdn.ireadabc.com/f6f4bbef497409fef3c8f1d375893829.png","audio_url":"http://staging-teach.cdn.ireadabc.com/fbe2f23b9eb191a9330f99800e0d54d5.mp3","text":""}]},{"title":"","letter":"B","audio_url":"http://staging-teach.cdn.ireadabc.com/f47f1d7b5c160fe1c59500d180346240.mp3","bg":"1","picArr":[{"letter":"b","word":"bbb","pic_url":"http://staging-teach.cdn.ireadabc.com/94cabac22be548c6dbab64c4be326547.png","audio_url":"http://staging-teach.cdn.ireadabc.com/66878465ec50d162bd60fcdaa641933b.mp3","text":""},{"letter":"b","word":"bcc","pic_url":"http://staging-teach.cdn.ireadabc.com/72f7fe7405f60ff641871f8823ed11a7.png","audio_url":"http://staging-teach.cdn.ireadabc.com/a4d27ad173a95823d4b8ec82363c5aa0.mp3","text":""},{"letter":"b","word":"bbb","pic_url":"http://staging-teach.cdn.ireadabc.com/843b9094eeada5a0c055f51655d623a5.png","audio_url":"http://staging-teach.cdn.ireadabc.com/85cff126986f5cc11b05e95181da5869.mp3","text":""}]}]}';
    var data1 = JSON.parse(dataJson);
    return data1;
  },
  preload: function preload() {
    var _this2 = this;

    var preloadArr = this._imageResList.concat(this._audioResList).concat(this._animaResList);

    cc.assetManager.loadAny(preloadArr, null, null, function (err, data) {
      console.log(' preload data, ', data); // typeof

      _this2.loadEnd();

      if (window && window["air"]) {
        window["air"].hideAirClassLoading();
      }
    });
  },
  addPreloadImage: function addPreloadImage() {
    if (this.data.bgItem) {
      this._imageResList.push({
        url: this.data.bgItem.url
      });
    }
  },
  addPreloadAudio: function addPreloadAudio() {
    var _this3 = this;

    this.data.groupArr.forEach(function (item) {
      _this3._audioResList.push({
        url: item.audio_url
      });

      item.picArr.forEach(function (subItem) {
        _this3._audioResList.push({
          url: subItem.audio_url
        });
      });
    });
  },
  addPreloadAnima: function addPreloadAnima() {
    if (!this.data.hotZoneItemArr) {
      return;
    }

    this.data.hotZoneItemArr.forEach(function (item) {// if (item.gIdx == '0') {
      // 	this._animaResList.push({url: item.skeJsonData.url});
      // 	this._animaResList.push({url: item.texJsonData.url});
      // 	this._animaResList.push({url: item.texPngData.url});
      // }
    });
  },
  loadEnd: function loadEnd() {
    this.initData();
    this.initAudio();
    this.initView();
    this.initListener();
  },
  audioEnter: null,
  audioTitle: null,
  audioBgm: null,
  audioWrong: null,
  audioRight: null,
  audioStar: null,
  audioBtn: null,
  audioFinish: null,
  initAudio: function initAudio() {
    var audioNode = cc.find('Canvas/res/audio');
    this.audioEnter = audioNode.getChildByName('enter').getComponent(cc.AudioSource);
    this.audioTitle = audioNode.getChildByName('title').getComponent(cc.AudioSource);
    this.audioBgm = audioNode.getChildByName('bgm').getComponent(cc.AudioSource);
    this.audioWrong = audioNode.getChildByName('wrong').getComponent(cc.AudioSource);
    this.audioRight = audioNode.getChildByName('right').getComponent(cc.AudioSource);
    this.audioStar = audioNode.getChildByName('star').getComponent(cc.AudioSource);
    this.audioBtn = audioNode.getChildByName('btn').getComponent(cc.AudioSource);
    this.audioFinish = audioNode.getChildByName('finish').getComponent(cc.AudioSource);
    cc.audioEngine.play(this.audioBgm.clip, true, 0.1); // this.audioBgm.loop = true;
    // this.audioBgm.play();
  },
  groupIdx: null,
  _cantouch: null,
  initData: function initData() {
    this.groupIdx = 0;
    this.curGroup = this.data.groupArr[this.groupIdx]; // this.curGroup.picArr = randomSortByArr(this.curGroup.picArr);

    this.initQuestionData();
    this.initOutlineMaterial();
    this.initCircleSpr();
    this.initFontFamily();
  },
  initFontFamily: function initFontFamily() {// const fontLabel = this.node.getChildByName('font').getComponent(cc.Label);
    // 	this._labelFont = fontLabel.font;
  },
  circleSpr: null,
  initCircleSpr: function initCircleSpr() {
    this.circleSpr = cc.find('Canvas/res/img/bg_zi').getComponent(cc.Sprite);
  },
  questionData: null,
  questionIndex: null,
  initQuestionData: function initQuestionData() {
    if (!this.curGroup) {
      return;
    }

    this.questionArr = (0, _util.randomSortByArr)(this.curGroup.picArr);
    this.questionIndex = 0;
    this.questionData = this.questionArr[this.questionIndex];
  },
  initView: function initView() {
    this.initBg();
    this.initWave();
    this.initBtn();
    this.initTrain();
    this.initTrainBox();
    this.addSoundBtnListener();
  },
  initListener: function initListener() {
    var _this4 = this;

    var canvas = cc.find('Canvas');

    if (canvas.hasEventListener(cc.Node.EventType.TOUCH_MOVE)) {
      return;
    }

    canvas.on(cc.Node.EventType.TOUCH_MOVE, function (e) {
      _this4.canvasTouchMove(e);
    });
    canvas.on(cc.Node.EventType.TOUCH_CANCEL, function (e) {
      _this4.canvasTouchEnd(e);
    });
    canvas.on(cc.Node.EventType.TOUCH_END, function (e) {
      _this4.canvasTouchEnd(e);
    });
  },
  _cocosScale: null,
  bg: null,
  frameSize: null,
  curGroup: null,
  initBg: function initBg() {
    var frameSize = cc.view.getFrameSize();
    this.frameSize = frameSize;
    var sx = cc.winSize.width / frameSize.width;
    var sy = cc.winSize.height / frameSize.height;
    var s = Math.min(sx, sy);
    this._cocosScale = s;
    console.log('data:', this.data); // const group = this.data.groupArr[0];

    if (!this.curGroup) {
      return;
    } // this.curGroup = group;


    var group = this.curGroup;
    var bgNode = cc.find('Canvas/bg_' + group.bg);
    bgNode.active = true;
    sx = frameSize.width / bgNode.width;
    sy = frameSize.height / bgNode.height;
    bgNode.scale = Math.max(sx, sy) * s;
    bgNode.anchorX = 1;
    bgNode.anchorY = 0;
    bgNode.x = frameSize.width / 2 * s;
    bgNode.y = -frameSize.height / 2 * s;
    this.bg = bgNode;
  },
  wave_1_1: null,
  wave_1_2: null,
  wave_2_1: null,
  wave_2_2: null,
  waveSpeed1: null,
  waveSpeed2: null,
  initWave: function initWave() {
    this.wave_1_1 = cc.find('Canvas/bg_wavefront_1');
    this.wave_1_2 = cc.find('Canvas/bg_wavefront_2');
    this.wave_2_1 = cc.find('Canvas/bg_wavebehind_1');
    this.wave_2_2 = cc.find('Canvas/bg_wavebehind_2');
    this.waveSpeed1 = -2;
    this.waveSpeed2 = -1;
  },
  initBtn: function initBtn() {
    var _this5 = this;

    var startBtn = cc.find('Canvas/btn_start');

    if (this.isRestart) {
      startBtn = cc.find('Canvas/btn_restart');
    }

    startBtn.active = true;
    startBtn.opacity = 255;
    startBtn.scale = 0;
    cc.tween(startBtn).to(0.5, {
      scale: 1
    }, {
      easing: 'elasticOut'
    }).start();
    cc.audioEngine.play(this.audioBtn.clip, false, 0.5);
    startBtn.once('click', function () {
      cc.audioEngine.play(_this5.audioBtn.clip, false, 0.5);
      cc.tween(startBtn).to(0.06, {
        scale: 0.8
      }).to(0.06, {
        scale: 1,
        opacity: 0
      }).call(function () {
        startBtn.active = false;

        _this5.showTrain();
      }).start();
    });
  },
  train: null,
  initTrain: function initTrain() {
    var _this6 = this;

    var cheW = 180;
    var trainNode = cc.find('Canvas/train');
    trainNode.baseX = trainNode.x;
    var train = trainNode.getChildByName('anima');
    var totalW = train.width + 180 * 5;
    this.train = train;
    var anima = train.getComponent(dragonBones.ArmatureDisplay);
    anima.off(dragonBones.EventObject.COMPLETE);
    anima.on(dragonBones.EventObject.COMPLETE, function (e) {
      if (anima.animationName == 'right') {
        _this6.train.getComponent(dragonBones.ArmatureDisplay).playAnimation('normal', -1);
      }
    });
    var frameSize = cc.view.getFrameSize();
    trainNode.scale = frameSize.width / totalW;
  },
  trainBox: null,
  initTrainBox: function initTrainBox() {
    this.trainBox = [];
    var trainNode = cc.find('Canvas/train');
    var picArr = this.curGroup ? this.curGroup.picArr : [];

    for (var i = 0; i < 5; i++) {
      var box = trainNode.getChildByName('che_' + (i + 1));
      var starNode = box.getChildByName('star');
      starNode.rotation = 0;
      starNode.active = false;

      if (box.item) {
        this.resetPicNode(box.item);
        box.item = null;
      }

      if (picArr[i]) {
        box.active = true;
        this.trainBox.push(box);
      } else {
        box.active = false;
      }
    }
  },
  resetPicNode: function resetPicNode(pNode) {
    pNode.parent = pNode.baseP;
    pNode.x = pNode.baseX;
    pNode.y = pNode.baseY;
    pNode.scale = 1;
    pNode.parent.active = false;
    pNode.anchorY = 0.5;
    pNode.box = null;
  },
  showTrain: function showTrain() {
    var _this7 = this;

    var frameSize = this.frameSize;
    var trainNode = cc.find('Canvas/train');
    var train = trainNode.getChildByName('anima');
    console.log('train: ', train);
    train.getComponent(dragonBones.ArmatureDisplay).playAnimation('move', -1);
    cc.tween(trainNode).to(3.3, {
      x: frameSize.width / 2 + train.width * 0.15
    }, {
      easing: 'sineOut'
    }).call(function () {
      _this7.stopTrain(train);

      _this7.showTitle(); // this.showPic();

    }).start();
    this.waveSpeed1 = -6;
    this.waveSpeed2 = -3;
    cc.audioEngine.play(this.audioEnter.clip, false, 0.2); // this.audioEnter.play();
  },
  stopTrain: function stopTrain(train) {
    train.getComponent(dragonBones.ArmatureDisplay).playAnimation('normal', -1);
    this.waveSpeed1 = -2;
    this.waveSpeed2 = -1;
  },
  showTitle: function showTitle() {
    var _this8 = this;

    var titleNode = cc.find('Canvas/title');
    titleNode.active = true;
    titleNode.opacity = 255;
    titleNode.y = this.frameSize.height / 4;
    titleNode.scale = 0;
    var star = titleNode.getChildByName('star');
    star.active = false;
    var letterBg = titleNode.getChildByName('bg_letter');
    letterBg.active = false;
    cc.tween(titleNode).to(0.9, {
      scale: 1
    }, {
      easing: 'elasticOut'
    }).call(function () {
      _this8.playAudioByUrl(_this8.curGroup.audio_url);

      _this8.showTitleLetter(titleNode);
    }).start();
    cc.audioEngine.play(this.audioTitle.clip, false, 0.5); // this.audioTitle.play();
  },
  font: null,
  showTitleLetter: function showTitleLetter(titleNode) {
    var _this9 = this;

    var letterBg = titleNode.getChildByName('bg_letter');
    letterBg.baseY = letterBg.y;
    letterBg.y = this.frameSize.height / 2;
    var label = letterBg.getChildByName('label').getComponent(cc.RichText);
    label.string = "<outline color=#fe538f width=5>" + this.curGroup.letter + "</outline>";
    this.font = label.font;
    cc.tween(letterBg).to(1.7, {
      y: letterBg.baseY
    }, {
      easing: 'bounceOut'
    }).call(function () {
      _this9.showTitleStar(titleNode);
    }).start();
    letterBg.active = true;
  },
  showTitleStar: function showTitleStar(titleNode) {
    var _this10 = this;

    var star = titleNode.getChildByName('star');
    star.active = true;
    star.scale = 0;
    star.rotation = 0;
    cc.tween(star).to(0.7, {
      rotation: 360,
      scale: 1
    }, {
      easing: 'cubicOut'
    }).delay(1).call(function () {
      _this10.hideTitle(titleNode);
    }).start();
  },
  hideTitle: function hideTitle(titleNode) {
    var _this11 = this;

    cc.tween(titleNode).to(0.7, {
      opacity: 0
    }, {
      easing: 'cubicIn'
    }).call(function () {
      _this11.showPic();
    }).start();
  },
  addSoundBtnListener: function addSoundBtnListener() {
    var _this12 = this;

    var btn = cc.find('Canvas/btn_laba');
    var anima = btn.getComponent(cc.Animation);

    if (btn.hasEventListener('click')) {
      return;
    }

    btn.on('click', function () {
      console.log('anima: ', anima);

      _this12.showSound();
    });
  },
  showSound: function showSound() {
    if (!this._cantouch) {
      return;
    }

    if (!this.questionData) {
      return;
    }

    var btn = cc.find('Canvas/btn_laba');
    var anima = btn.getComponent(cc.Animation);
    anima.play('laba');
    this.playAudioByUrl(this.questionData.audio_url);
  },
  playAudioByUrl: function playAudioByUrl(audio_url) {
    if (audio_url) {
      cc.assetManager.loadRemote(audio_url, function (err, audioClip) {
        cc.audioEngine.play(audioClip, false, 0.8);
      });
    }
  },
  showPic: function showPic() {
    var _this13 = this;

    // console.log('data:', this.data)
    if (!this.curGroup || !this.curGroup.picArr) {
      return;
    }

    this._cantouch = true;
    this.showSound();
    var picLen = 300;
    var picArr = this.curGroup.picArr;
    var posNode = cc.find('Canvas/posNode/node_' + picArr.length);
    posNode.active = true;
    var index = 0;
    picArr.forEach(function (item) {
      console.log('item: ', item);
      var picNode = posNode.getChildByName('p_' + (index + 1));
      picNode.baseX = picNode.x;
      picNode.baseY = picNode.y;
      picNode.baseP = picNode.parent;
      picNode.data = item;
      index++;
      picNode.scale = 0;
      cc.loader.load({
        url: item.pic_url
      }, function (err, img) {
        // const spr = picNode.addComponent(cc.Sprite);
        var spr = picNode.getComponent(cc.Sprite);
        spr.spriteFrame = new cc.SpriteFrame(img);
        var sx = picLen / picNode.width;
        var sy = picLen / picNode.height;
        var s = Math.min(sx, sy); // picNode.baseS = s;

        cc.tween(picNode).delay(Math.random() * 0.2).to(0.5, {
          scale: s
        }, {
          easing: 'elasticOut'
        }).start();

        _this13.addPicTouchListener(picNode);

        if (!spr.baseMaterial) {
          spr.baseMaterial = spr.getMaterial(0);
        }

        var letterNode = picNode.letterNode;

        if (!picNode.letterNode) {
          letterNode = new cc.Node();
          var letterBg = letterNode.addComponent(cc.Sprite);
          letterBg.spriteFrame = _this13.circleSpr.spriteFrame;
          letterNode.parent = picNode;
          var labelNode = new cc.Node();
          labelNode.parent = letterNode;
          var label = labelNode.addComponent(cc.RichText);
          label.font = _this13.font;
          label.fontSize = 90;
          label.verticalAlign = cc.Label.VerticalAlign.CENTER; // labelNode.anchorY = 0.5;

          labelNode.y = 7;
          label.lineHeight = letterNode.height;

          if (Math.random() < 0.5) {
            labelNode.color = new cc.Color(0, 162, 255);
          } else {
            labelNode.color = new cc.Color(245, 50, 39);
          }

          picNode.label = label;
          picNode.letterNode = letterNode;
        }

        letterNode.active = true;
        letterNode.scale = 1 / s;
        letterNode.x = picNode.width / 2;
        letterNode.y = picNode.height / 2;
        picNode.label.string = item.letter;
      });
    });
  },
  outlineMaterial: null,
  initOutlineMaterial: function initOutlineMaterial() {
    var spr = cc.find('Canvas/material').getComponent(cc.Sprite); // var material = cc.Material.getInstantiatedMaterial(spr.sharedMaterials[0], this.node)

    this.outlineMaterial = spr.getMaterial(0); // let material = cc.Material.createWithBuiltin('unlit');
    // // 材质 material 的修改会影响到 variant1 和 variant2
    // material.setProperty('diffuseColor', cc.Color.WHITE);
    // this.outlineMaterial = material;

    console.log('this.outlineMaterial: ', this.outlineMaterial);
  },
  showOutline: function showOutline() {
    var spr = this._curShowItem.getComponent(cc.Sprite);

    var m = cc.MaterialVariant.create(this.outlineMaterial, spr); // console.log('m: ', m);

    spr.setMaterial(0, m); // let variant1 = cc.MaterialVariant.createWithBuiltin(cc.Material.BUILTIN_NAME.SPRITE);
    // 设置材质到指定索引，一般来说 2d 渲染组件的 index 都是 0
    // variant1 由于没有指定 owner render component，所以会直接被 renderComponent1 使用并且设置 owner 为 renderComponent1
    // spr.setMaterial(0, variant1);
    // spr.setMaterial(0, this.outlineMaterial);
    // spr.markForRender(true);
  },
  hideOutLine: function hideOutLine() {
    var spr = this._curShowItem.getComponent(cc.Sprite);

    spr.setMaterial(0, spr.baseMaterial);
  },
  _curShowItem: null,
  addPicTouchListener: function addPicTouchListener(node) {
    var _this14 = this;

    if (node.hasEventListener('cc.Node.EventType.TOUCH_START')) {
      return;
    }

    node.on(cc.Node.EventType.TOUCH_START, function (e) {
      if (!_this14._cantouch) {
        return;
      }

      if (node.box) {
        return;
      }

      _this14._cantouch = false;
      e.bubbles = false;
      _this14._curShowItem = node;

      _this14.playAudioByUrl(_this14._curShowItem.data.audio_url);

      _this14.showOutline();
    });
  },
  canvasTouchMove: function canvasTouchMove(e) {
    if (!this._curShowItem) {
      return;
    }

    var pos = e.getLocation();
    this._curShowItem.x = pos.x - e.currentTarget.width / 2;
    this._curShowItem.y = pos.y - e.currentTarget.height / 2;
  },
  canvasTouchEnd: function canvasTouchEnd(e) {
    if (!this._curShowItem) {
      return;
    }

    this.checkOnTargetBox(e);
    this._curShowItem = null;
  },
  checkOnTargetBox: function checkOnTargetBox(e) {
    var checkLen = 100 * this._cocosScale;
    var minLen = checkLen,
        curBox;

    for (var i = 0; i < this.trainBox.length; i++) {
      var worldStartPos = this._curShowItem.parent.convertToWorldSpaceAR(this._curShowItem);

      var tmpP = cc.v2(this.trainBox[i].x - this.trainBox[i].width / 2, this.trainBox[i].y + this.trainBox[i].height / 2);
      var worldEndPos = this.trainBox[i].parent.convertToWorldSpaceAR(tmpP);
      var tmpLen = (0, _util.getDistance)(worldStartPos, worldEndPos);

      if (tmpLen <= minLen && !this.trainBox[i].item) {
        curBox = this.trainBox[i];
        minLen = tmpLen;
      }
    }

    if (curBox && this._curShowItem.data.audio_url == this.questionData.audio_url) {
      this.addBoxPic(curBox, this._curShowItem);
    } else {
      this.itemBack();
    }
  },
  itemBack: function itemBack() {
    var _this15 = this;

    var startPos = cc.v2(this._curShowItem.x, this._curShowItem.y);
    var endPos = cc.v2(this._curShowItem.baseX, this._curShowItem.baseY);
    var distance = startPos.sub(endPos).mag(); // if (distance <= 20 && this._curShowItem.data.audioClip) {
    // 	cc.audioEngine.stopAll();
    // 	cc.audioEngine.play(this._curShowItem.data.audioClip, false, 0.8);
    // } else {
    // this._wrongAudioSource.play();
    // }

    var backItem = this._curShowItem;
    cc.tween(backItem).to(0.3, {
      x: backItem.baseX,
      y: backItem.baseY
    }, {
      easing: 'elasticOut'
    }).call(function () {
      // backItem.bgBottomItem.opacity = 255;
      // backItem.removeFromParent();
      // backItem.data.isDrag = false;
      _this15._cantouch = true;
    }).start();
    this.hideOutLine();
    cc.audioEngine.play(this.audioWrong.clip, false, 0.5);
  },
  addBoxPic: function addBoxPic(box, showItem) {
    showItem.parent = box;
    showItem.x = -box.width / 2 - 12;
    showItem.y = box.height / 2 + 2;
    showItem.zIndex = -1;
    box.item = showItem;
    showItem.box = box;
    showItem.scale = box.width * 0.8 / showItem.width;
    showItem.anchorY = 0;
    var baseS = showItem.scale;
    showItem.scale = 0;
    showItem.letterNode.active = false;
    cc.tween(showItem).to(0.3, {
      scale: baseS
    }, {
      easing: 'sineOut'
    }).start();
    this.showBoxStar(box);
    this.hideOutLine();
  },
  showBoxStar: function showBoxStar(box) {
    var _this16 = this;

    var star = box.getChildByName('star');
    var parent = star.parent;
    star.baseX = star.x;
    star.baseY = star.y;
    star.baseS = 0.15; // star.scale;

    star.zIndex = 10;
    star.parent = cc.find('Canvas');
    star.active = true;
    star.scale = 0;
    var worldPos = parent.convertToWorldSpaceAR(cc.v2(star.baseX, star.baseY));
    var pos = star.parent.convertToNodeSpaceAR(cc.v2(worldPos.x, worldPos.y));
    cc.tween(star).to(0.7, {
      scale: 1
    }, {
      easing: 'elasticOut'
    }).delay(0.3).to(1.5, {
      rotation: 360,
      scale: star.baseS,
      x: pos.x,
      y: pos.y
    }, {
      easing: 'cubicOut'
    }).call(function () {
      var worldRect1 = star.getBoundingBoxToWorld();
      star.parent = box;
      star.x = star.baseX;
      star.y = star.baseY;
      var worldRect2 = star.getBoundingBoxToWorld();
      var sx = worldRect1.width / worldRect2.width;
      star.scale *= sx;

      _this16.showTrainRight();
    }).start();
    cc.audioEngine.play(this.audioStar.clip, false, 0.3);
  },
  showTrainRight: function showTrainRight() {
    var anima = this.train.getComponent(dragonBones.ArmatureDisplay);
    anima.playAnimation('right', 1); // let arma = anima.armature();

    cc.audioEngine.play(this.audioRight.clip, false, 0.5);
    this.changeQuestion();
    this._cantouch = true;
  },
  changeQuestion: function changeQuestion() {
    var _this17 = this;

    console.log(' in changeQuestion');
    this.questionIndex++;
    this.questionData = this.questionArr[this.questionIndex];

    if (!this.questionData) {
      if (this.groupIdx == this.data.groupArr.length - 1) {
        this.showParticle();
      } else {
        setTimeout(function () {
          _this17.showTrainLeave();
        }, 500);
      }

      return;
    }

    setTimeout(function () {
      _this17.showSound();
    }, 500);
  },
  showTrainLeave: function showTrainLeave() {
    var _this18 = this;

    console.log(' in  showTrainLeave');
    var trainNode = cc.find('Canvas/train');
    this.train.getComponent(dragonBones.ArmatureDisplay).playAnimation('move', -1);
    this.waveSpeed1 = -6;
    this.waveSpeed2 = -3;
    cc.audioEngine.play(this.audioEnter.clip, false, 0.2);
    cc.tween(trainNode).to(3.1, {
      x: this.frameSize.width * 1.5
    }, {
      easing: 'sineIn'
    }).call(function () {
      _this18.waveSpeed1 = -2;
      _this18.waveSpeed2 = -1;
      trainNode.x = trainNode.baseX;

      _this18.nextGroup();
    }).start();
  },
  nextGroup: function nextGroup() {
    this.setNextGroupData();
    this.initQuestionData();
    this.initTrainBox();

    if (!this.curGroup) {
      this.showRestart();
    } else {
      this.showTrain();
    }
  },
  isRestart: null,
  showRestart: function showRestart() {
    this.isRestart = true;
    this.initData();
    this.initView();
  },
  setNextGroupData: function setNextGroupData() {
    this.groupIdx++;
    this.curGroup = this.data.groupArr[this.groupIdx];
  },
  showParticle: function showParticle() {
    var _this19 = this;

    var pNode = cc.find('Canvas/particle_finish');
    pNode.active = true;
    var particle = pNode.getComponent(cc.ParticleSystem);
    particle.resetSystem();
    cc.audioEngine.play(this.audioFinish.clip, false, 0.5);
    setTimeout(function () {
      _this19.showTrainLeave();
    }, 1000);
  },
  checkWaveOnEdge: function checkWaveOnEdge(wave1, wave2) {
    var waveLeft, waveRight;

    if (wave1.x < wave2.x) {
      waveLeft = wave1;
      waveRight = wave2;
    } else {
      waveLeft = wave2;
      waveRight = wave1;
    }

    var worldRect = waveLeft.getBoundingBoxToWorld();

    if (worldRect.x + worldRect.width < 0) {
      waveLeft.x = waveRight.x + waveRight.width * Math.abs(waveRight.scaleX) - 1;
    }
  },
  updateWave: function updateWave() {
    if (!this.wave_1_1) {
      return;
    }

    this.wave_1_1.x += this.waveSpeed1;
    this.wave_1_2.x += this.waveSpeed1;
    this.wave_2_1.x += this.waveSpeed2;
    this.wave_2_2.x += this.waveSpeed2;
    this.checkWaveOnEdge(this.wave_1_1, this.wave_1_2);
    this.checkWaveOnEdge(this.wave_2_1, this.wave_2_2);
  },
  update: function update(dt) {
    this.updateWave();
  }
}); // initHotZone() {
// 	this.initHotZoneBg();
// },
// hotZoneBg: null,
// initHotZoneBg() {
// 	this.hotZoneBg = new cc.Node();
// 	this.hotZoneBg.name = 'hotZoneBg';
// 	this.hotZoneBg.parent = cc.find('Canvas');
// 	this.hotZoneBg.zIndex = 4;
// 	const canvas = cc.find('Canvas/Main Camera');
// 	// console.log('canvas: ', canvas);
// 	if (!this.data.bgItem) {
// 		return;
// 	}
// 	cc.loader.load({url: this.data.bgItem.url}, (err, img) => {
// 		this.addMask(this.hotZoneBg);
// 		this.hotZoneBg.width = img.width;
// 		this.hotZoneBg.height = img.height;
// 		const box = this.hotZoneBg.getBoundingBox();
// 		const tmpS = 640 / 720;
// 		let subNum = 720 - 640;
// 		const frameSize = cc.view.getFrameSize();
// 		const winSize = cc.winSize;
// 		console.log('this.hotZoneBg.box: ', this.hotZoneBg.getBoundingBox());
// 		console.log('let visiSize=cc.director.getVisibleSize();: ', cc.view.getVisibleSize());
// 		console.log('lframeSize: ', frameSize);
// 		let sx = frameSize.width / this._designSize.width;
// 		let sy = frameSize.height / this._designSize.height;
// 		const mapS = Math.min(sx, sy);
// 		// const sy = canvas.height * tmpS / box.height;
// 		const bgBottom = cc.find('Canvas/bgBottom');
// 		bgBottom.scale = mapS * this._cocosScale;
// 		// subNum = bgBottom.height;
// 		 sx = frameSize.width * this._cocosScale / img.width;
// 		 sy = (frameSize.height * this._cocosScale - subNum * mapS * this._cocosScale) / img.height;
// 		const sprNode = new cc.Node();
// 		var sf = new cc.SpriteFrame(img);
// 		// const spr = this.hotZoneBg.addComponent(cc.Sprite);
// 		const spr = sprNode.addComponent(cc.Sprite);
// 		spr.spriteFrame = sf
// 		sprNode.width = this.hotZoneBg.width;
// 		sprNode.height = this.hotZoneBg.height;
// 		sprNode.parent = this.hotZoneBg;
// 		this.hotZoneBg.scale = Math.min(sx, sy);
// 		// this.hotZoneBg.y = -frameSize.height / 2 * this._cocosScale + this.hotZoneBg.height / 2 * this.hotZoneBg.scaleY + (subNum * mapS * this._cocosScale);
// 		this.hotZoneBg.y = frameSize.height / 2 * this._cocosScale - this.hotZoneBg.height / 2 * this.hotZoneBg.scaleY ;
// 		// this.hotZoneBg.opacity = 20;
// 		const bgWhite = cc.find('Canvas/bgWhite');
// 		bgWhite.y = this.hotZoneBg.y;
// 		bgWhite.scaleX = this.hotZoneBg.width * this.hotZoneBg.scaleX / bgWhite.width;
// 		bgWhite.scaleY = this.hotZoneBg.height * this.hotZoneBg.scaleY / bgWhite.height;
// 		const canvas = cc.find('Canvas');
// 		const shadowNode = new cc.Node();
// 		shadowNode.y = bgWhite.y;
// 		shadowNode.scaleX = bgWhite.scaleX;
// 		shadowNode.scaleY = bgWhite.scaleY;
// 		canvas.addChild(shadowNode);
// 		const ctx = shadowNode.addComponent(cc.Graphics);
// 		ctx.fillColor = cc.Color.BLACK.setA(30);
// 		// ctx.fillRect(5, 5, this.hotZoneBg.width*this.hotZoneBg.scaleX, this.hotZoneBg.height * this.hotZoneBg.scaleY);
// 		ctx.fillRect(-bgWhite.width / 2 + 8 / bgWhite.scaleX * this.hotZoneBg.scale, -bgWhite.height / 2 - 8 / bgWhite.scaleX * this.hotZoneBg.scale, bgWhite.width, bgWhite.height);
// 		ctx.fill();
// 		shadowNode.zIndex = 1;
// 		bgWhite.zIndex = 2;
// 		bgBottom.y = -frameSize.height / 2 * this._cocosScale - 15 * bgBottom.scaleY;
// 		this.initSoundControler();
// 		this.data.hotZoneItemArr.forEach((item) => {
// 			// if (item.gIdx == '0') {
// 			// 	this.setOneAnima(item);
// 			// } else if (item.gIdx == '1') {
// 			// 	this.setOnePic(item);
// 			// }
// 			this.setOneAnima(item);
// 			// this.setOneCircle(item);
// 		});
// 	});
// },
// addMask(node) {
// 	const mask = node.addComponent(cc.Mask);
// 	mask.type = cc.Mask.Type.RECT;
// },
// initBottomPart() {cc.audioEngine.play(this.audioBtn.clip, false, 0.5)
// 	const bgBottom = cc.find('Canvas/bgBottom');
// 	const script = bgBottom.getComponent('bgBottom');
// 	script.setItemData(this.data.hotZoneItemArr);
// },
// setOneAnima(data) {
// 	const rate = (this.hotZoneBg.scale * this.hotZoneBg.width) / this.data.bgItem.rect.width;
// 	const rectNode = new cc.Node();
// 	rectNode.name = 'rect' + data.index;
// 	this.hotZoneBg.addChild(rectNode);
// 	const ctx = rectNode.addComponent(cc.Graphics);
// 	// 红色矩形
// 	ctx.lineWidth = 4;
// 	ctx.strokeColor = cc.Color.BLACK;
// 	ctx.fillColor = cc.Color.WHITE.setA(100);
// 	const scale = rate / this.hotZoneBg.scaleY;
// 	rectNode.width = data.rect.width * scale;
// 	rectNode.height = data.rect.height * scale;
// 	rectNode.x = -this.hotZoneBg.width / 2 + data.rect.x * scale;
// 	rectNode.y = this.hotZoneBg.height / 2 - data.rect.height * scale - data.rect.y * scale;
// 	rectNode.anchorX = rectNode.anchorY = 0;
// 	if (this.data.bgItem.isShowDebugLine) {
// 		ctx.rect(0, 0, rectNode.width, rectNode.height);
// 	}
// 	ctx.stroke();
// 	ctx.fill();
// 	const animaNode = new cc.Node();
// 	animaNode.name = 'anima_' + data.index;
// 	this.hotZoneBg.addChild(animaNode);
// 	if (data.audio_url) {
// 		cc.assetManager.loadRemote(data.audio_url, (err, audioClip) => {
// 			animaNode.audioClip = audioClip;
// 			data.audioClip = audioClip;
// 			if (data.index == this._soundDataArr[this._soundDataIndex].index) {
// 				this.playSoundData();
// 			}
// 		});
// 	}
// 	const dragonDisplay = animaNode.addComponent(dragonBones.ArmatureDisplay);
// 	const image = data.texPngData.url//"http://staging-teach.cdn.ireadabc.com/5a0c5af3e952acd0ac83a6e5c6f03ff1.png";
// 	const ske = data.skeJsonData.url//"http://staging-teach.cdn.ireadabc.com/bd825dcceea298d1146be8067ae3d17f.json";
// 	const atlas = data.texJsonData.url//"http://staging-teach.cdn.ireadabc.com/246f8991b729fa3e5a7f4802de828efa.json";
// 	cc.loader.load(image, (error, texture) => {
// 		cc.loader.load({url: atlas, type: 'txt'}, (error, atlasJson) => {
// 			cc.loader.load({url: ske, type: 'txt'}, (error, dragonBonesJson) => {
// 				const atlas = new dragonBones.DragonBonesAtlasAsset();
// 				atlas.atlasJson = atlasJson;
// 				atlas.texture = texture;
// 				const asset = new dragonBones.DragonBonesAsset();
// 				asset.dragonBonesJson = dragonBonesJson;
// 				dragonDisplay.dragonAtlasAsset = atlas;
// 				dragonDisplay.dragonAsset = asset;
// 				let json = JSON.parse(asset.dragonBonesJson);
// 				let armatures = json["armature"];
// 				console.log('armatures: ', armatures);
// 				let armatureNames = [];
// 				for (let i = 0; i < armatures.length; i++) {
// 					armatureNames.push(armatures[i].name);
// 				}
// 				// console.log('armatureNames: ', armatureNames);
// 				if (armatureNames.length > 0) {
// 					let defaultArmatureName = armatureNames[0];
// 					dragonDisplay.armatureName = defaultArmatureName;
// 					// let animationNames = dragonDisplay.getAnimationNames(defaultArmatureName);
// 					let defaultArmature = armatures[0];
// 					let animations = defaultArmature.animation;
// 					let animationNames = [];
// 					for (let i = 0; i < animations.length; i++) {
// 						animationNames.push(animations[i].name);
// 					}
// 					rectNode.addComponent(cc.Button);
// 					rectNode.on('click', () => {
// 						cc.audioEngine.stopAll();
// 						if (data.index == this._soundDataArr[this._soundDataIndex].index) {
// 							const id = cc.audioEngine.play(this._rightAudio.clip, false, 0.8);
// 							cc.audioEngine.setFinishCallback(id, () => {
// 								if (animaNode.audioClip) {
// 									// cc.audioEngine.stopAll();
// 									cc.audioEngine.play(animaNode.audioClip, false, 0.8);
// 								}
// 							});
// 						} else {
// 							this._wrongAudio.play();
// 							return;
// 						}
// 						if (rectNode.isClicked) {
// 							// return;
// 						}
// 						rectNode.isClicked = true;
// 						console.log('clicked');
// 						if (animationNames.length > 0) {
// 							dragonDisplay.playAnimation(animationNames[0], 1);
// 						}
// 					});
// 				}
// 			});
// 		});
// 	});
// },
// setOnePic(data) {
// 	const rate = (this.hotZoneBg.scale * this.hotZoneBg.width) / this.data.bgItem.rect.width;
// 	const picNode = new cc.Node();
// 	picNode.data = data;
// 	this.hotZoneBg.addChild(picNode);
// 	cc.loader.load({url: data.pic_url}, (err, img) => {
// 		const spr = picNode.addComponent(cc.Sprite);
// 		spr.spriteFrame = new cc.SpriteFrame(img)
// 		const scale = rate / this.hotZoneBg.scaleY;
// 		picNode.width = data.rect.width * scale;
// 		picNode.height = data.rect.height * scale;
// 		picNode.x = -this.hotZoneBg.width / 2 + data.rect.x * scale;
// 		picNode.y = this.hotZoneBg.height / 2 - data.rect.height * scale - data.rect.y * scale;
// 		picNode.anchorX = picNode.anchorY = 0;
// 	});
// },
// setOneCircle(data) {
// 	const rate = (this.hotZoneBg.scale * this.hotZoneBg.width) / this.data.bgItem.rect.width;
// 	const rectNode = new cc.Node();
// 	rectNode.name = 'rect' + data.index;
// 	rectNode.data = data;
// 	this.hotZoneBg.addChild(rectNode);
// 	const scale = rate / this.hotZoneBg.scaleY;
// 	rectNode.width = data.rect.width * scale;
// 	rectNode.height = data.rect.height * scale;
// 	rectNode.x = -this.hotZoneBg.width / 2 + data.rect.x * scale;
// 	rectNode.y = this.hotZoneBg.height / 2 - data.rect.height * scale - data.rect.y * scale;
// 	rectNode.anchorX = rectNode.anchorY = 0;
// 	if (data.audio_url) {
// 		cc.assetManager.loadRemote(data.audio_url, (err, audioClip) => {
// 			data.audioClip = audioClip;
// 		});
// 	}
// 	rectNode.addComponent(cc.Button);
// 	rectNode.on('click', () => {
// 		this.showCircle(rectNode);
// 	});
// },
// _circle: null,
// initCircle() {
// 	this._circle = cc.find('Canvas/circle');
// 	this._circle.active = false;
// 	this._circle.zIndex = 12;
// },
// showCircle(node) {
// 	console.log(' in showCircle');
// 	if (node == this._circle.itemNode) {
// 		if (node.data.audioClip) {
// 			cc.audioEngine.stopAll();
// 			cc.audioEngine.play(node.data.audioClip, false, 0.8);
// 		}
// 		return;
// 	}
// 	this._circle.itemNode = node;
// 	node.x += node.width / 2;
// 	node.y += node.height / 2;
// 	const rate = getScaleRateBy2Node(this._circle, node);
// 	const pos = localPosTolocalPos(this._circle, node);
// 	node.x -= node.width / 2;
// 	node.y -= node.height / 2;
// 	this._circle.scale *= rate;
// 	this._circle.scale *= (5/4);
// 	this._circle.x = pos.x;
// 	this._circle.y = pos.y;
// 	this._circle.active = true;
// 	this._circle.opacity = 0;
// 	cc.tween(this._circle)
// 		.to(1, {opacity: 255}, {easing: 'cubicOut'})
// 		.start();
// },
// initListener() {
// 	const canvas = cc.find('Canvas');
// 	canvas.addComponent(cc.Button);
// 	canvas.on('click', () => {
// 		// this.hideCircle();
// 		this._wrongAudio.play();
// 	});
// },
// hideCircle() {
// 	this._circle.itemNode = null;
// 	cc.tween(this._circle)
// 		.to(1, {opacity: 0}, {easing: 'cubicOut'})
// 		.start();
// },
// _soundDataArr: null,
// _soundDataIndex: null,
// initSoundControler() {
// 	console.log(' in initSoundControler')
// 	const controler = cc.find('Canvas/soundControler');
// 	controler.zIndex = 15;
// 	const node = new cc.Node();
// 	node.x = this.hotZoneBg.width / 2;
// 	node.y = -this.hotZoneBg.height / 2;
// 	node.parent = this.hotZoneBg;
// 	const pos = localPosTolocalPos(controler, node);
// 	controler.x = pos.x;
// 	controler.y = pos.y;
// 	this._soundDataIndex = 0;
// 	// this._soundDataArr = JSON.parse(JSON.stringify(this.data.hotZoneItemArr));
// 	this._soundDataArr = randomSortByArr(this.data.hotZoneItemArr);
// 	this.initAuidoEffect();
// 	this.initSoundControlerLeftBtn();
// 	this.initSoundControlerRightBtn();
// 	this.initSoundControlerResettBtn();
// 	this.refreshSoundControlerState();
// 	// this.playSoundData();
// },
// _wrongAudio: null,
// _rightAudio: null,
// initAuidoEffect() {
// 	this._wrongAudio = cc.find('Canvas/res/wrong_audio').getComponent(cc.AudioSource);
// 	this._rightAudio = cc.find('Canvas/res/right_audio').getComponent(cc.AudioSource);
// },
// playAudioByPlayEndId(id, clip) {
// 	cc.audioEngine.setFinishCallback(id, () => {
// 	});
// },
// _leftBtn: null,
// initSoundControlerLeftBtn() {
// 	const leftBtn = cc.find('Canvas/soundControler/left_btn');
// 	leftBtn.on(cc.Node.EventType.TOUCH_START, (e) => {
// 		e.bubbles = false;
// 		if (leftBtn.opacity != 255) {
// 			return;
// 		}
// 		this._soundDataIndex --;
// 		this.refreshSoundControlerState();
// 		this.playSoundData();
// 	});
// 	this._leftBtn = leftBtn;
// },
// _rightBtn: null,
// initSoundControlerRightBtn() {
// 	const rightBtn = cc.find('Canvas/soundControler/right_btn');
// 	rightBtn.on(cc.Node.EventType.TOUCH_START, (e) => {
// 		e.bubbles = false;
// 		if (rightBtn.opacity != 255) {
// 			return;
// 		}
// 		this._soundDataIndex ++;
// 		this.refreshSoundControlerState();
// 		this.playSoundData();
// 	});
// 	this._rightBtn = rightBtn;
// },
// _resetBtn: null,
// initSoundControlerResettBtn() {
// 	const resetBtn = cc.find('Canvas/soundControler/reset_btn');
// 	resetBtn.on(cc.Node.EventType.TOUCH_START, (e) => {
// 		e.bubbles = false;
// 		this.playSoundData();
// 	});
// 	this._resetBtn = resetBtn;
// },
// refreshSoundControlerState() {
// 	this._leftBtn.opacity = 255;
// 	this._rightBtn.opacity = 255;
// 	if (this._soundDataIndex == 0) {
// 		this._leftBtn.opacity = 100;
// 	}
// 	if (this._soundDataIndex == this._soundDataArr.length - 1) {
// 		this._rightBtn.opacity = 100;
// 	}
// },
// playSoundData() {
// 	const data = this._soundDataArr[this._soundDataIndex];
// 	if (data.audioClip) {
// 		cc.audioEngine.stopAll();
// 		cc.audioEngine.play(data.audioClip, false, 0.8);
// 		console.log('play sound');
// 	}
// },

cc._RF.pop();